#include "creature.h"
#include <stdio.h>

void creature_print(creature *creat)
{
	printf("Creature: %i muscles\n", creat->musclec);
	for (int i = 0; i < creat->musclec; ++i)
	{
		printf("\tMuscle %i: \n", i);
		printf("\t\tmultiplier: %f\n", creat->muscles[i].multiplier);
		printf("\t\tstrength: %i\n", creat->muscles[i].strength);

		printf("\t\tnode 1: ");
		node n = creat->muscles[i].n1;
		printf("friction: %i, x: %f, y: %f\n", n.friction, n.x, n.y);

		printf("\t\tnode 2: ");
		n = creat->muscles[i].n2;
		printf("friction: %i, x: %f, y: %f\n", n.friction, n.x, n.y);
	}
}

void creature_update(creature *creat, int dt)
{
	creat->muscles[0].n1.x += 0.06 * dt;
	creat->muscles[0].n2.x -= 0.01 * dt;
	creat->muscles[0].n2.y += 0.02 * dt;
}

static void drawnode(node n, SDL_Renderer *renderer)
{
	int w = 30;
	int h = 30;
	SDL_Rect rect = { n.x - (w / 2), n.y - (h / 2), w, h };
	int col = (n.friction / 1000.0) * 0xff;
	SDL_SetRenderDrawColor(renderer, 0xaa, col, col, 0xff);
	SDL_RenderFillRect(renderer, &rect);
}

void creature_draw(creature *creat, SDL_Renderer *renderer)
{
	for (int i = 0; i < creat->musclec; ++i)
	{
		muscle mus = creat->muscles[i];

		// Draw muscle line
		int col = (mus.strength / 1000.0) * 0xff;
		SDL_SetRenderDrawColor(renderer, 0xaa, 0xff, 0xaa, col);
		SDL_RenderDrawLine(renderer,
			mus.n1.x, mus.n1.y,
			mus.n2.x, mus.n2.y);

		// Draw nodes
		drawnode(mus.n1, renderer);
		drawnode(mus.n2, renderer);
	}
}
