#include <SDL2/SDL.h>
#include "creature.h"

int main()
{
	// Initialize SDL
	if (SDL_Init(SDL_INIT_VIDEO) != 0)
	{
		fprintf(stderr, "SDL_Init error: %s\n", SDL_GetError());
		return 1;
	}

	// Create a window
	SDL_Window *win = SDL_CreateWindow(
		"BestGame",
		100, 100,
		640, 480,
		SDL_WINDOW_SHOWN);
	if (win == NULL)
	{
		fprintf(stderr, "SDL_CreateWindow error: %s\n", SDL_GetError());
		SDL_Quit();
		return 1;
	}

	// Get surface and renderer
	SDL_Surface *surface = SDL_GetWindowSurface(win);
	SDL_Renderer *renderer = SDL_CreateRenderer(
		win, -1, SDL_RENDERER_ACCELERATED);

	// Create a creature
	creature creat = {
		.muscles = {
			{
				.n1 = { 10, 200, 200 },
				.n2 = { 10, 190, 300 },
				.multiplier = 1,
				.strength = 1
			}
		},
		.musclec = 1
	};

	int fps = 30;
	int delay = 1000 / fps;

	for (int i = 0; i < 100; ++i)
	{
		// Clear screen
		SDL_SetRenderDrawColor(renderer, 0, 0, 0, 0xff);
		SDL_RenderClear(renderer);

		// Update and draw creature
		creature_update(&creat, delay);
		creature_draw(&creat, renderer);

		// Presnent and delay
		SDL_RenderPresent(renderer);
		SDL_Delay(delay);
	}

	SDL_DestroyWindow(win);
	SDL_Quit();
	return 0;
}
